﻿using System;
using System.Collections.Generic;
using System.Linq;
using NHibernate;
using FluentNHibernate.Cfg;
using System.Reflection;
using FluentNHibernate.Cfg.Db;
using System.Drawing;

namespace BlobRepro
{
	static class Program
	{
		static void Main ()
		{
			ISessionFactory sessionFactory = 
				Fluently.Configure ()
				.Mappings (config => config.FluentMappings.AddFromAssembly (Assembly.GetExecutingAssembly ())
						     .ExportTo ("."))
				.Database (MsSqlConfiguration.MsSql2008
					   .ConnectionString (@"Data Source=.\SQLEXPRESS;Initial Catalog=BlobReproDb;Integrated Security=True"))
				.BuildSessionFactory ();

			TestEntity testEntity = new TestEntity ();
			testEntity.Image = Bitmap.FromFile ("food-photo.jpg");
			int id = -1;

			using (ISession session = sessionFactory.OpenSession ()) {
				session.SaveOrUpdate (testEntity);
				session.Flush ();
				id = testEntity.Id;
			}

			using (ISession session = sessionFactory.OpenSession ()) {
				testEntity = session.Get<TestEntity> (id);
			}
		}
	}
}
